/* Copyright (c) 1996 University of Utah.  All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for NON-COMMERCIAL purposes and without fee is
 * hereby granted provided that this copyright notice appears in all
 * copies.
 *
 * See http://www.cs.utah.edu/~hamlet for more educational resources.
 *
 * The University of Utah MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT
 * THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT. The University of Utah SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package RodStacker;

import RodStacker.*;
import java.awt.*;
import hamlet.*;

class AnswerFrame extends Frame
{
	private final static int FRAME_WIDTH = 175;
	private final static int FRAME_HEIGHT = 240;
	private NumericLabel a;
	private NumericLabel b;
	private NumericLabel c;
	private NumericLabel d;
	private NumericLabel e;
	private NumericLabel cosA;
	private NumericLabel cosB;
	private NumericLabel sinA;
	private NumericLabel sinB;
	Button closeButton = new Button ("Close");
	Panel numbers;
	Component parent;
	
	public AnswerFrame(String title, double ia, double ib, 
			   double ic, double id, double ie,
			   double icosA, double icosB, 
			   double isinA, double isinB, Component parentIn)
	{
	  
		super(title); //call the superconstructor
		
		// Set up the close button on the answer frame
		Panel closePanel = new Panel();
		closePanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		closePanel.add(closeButton);

		numbers = new Panel();
		numbers.setLayout(new GridLayout(9,1));
		//set up the font to use for all the labels.
		Font numFont = new Font("Courier", Font.PLAIN, 12);
		
		//set up a layout manager
		setLayout(new BorderLayout());
		add("North", closePanel);
		
		//add the labels
		a = new NumericLabel("a =", ia, Label.LEFT);
		a.setFont(numFont);
		numbers.add(a);
		
		b = new NumericLabel("b =", ib, Label.LEFT);
		b.setFont(numFont);
		numbers.add(b);
		
		c = new NumericLabel("c =", ic, Label.LEFT);
		c.setFont(numFont);
		numbers.add(c);
		
		d = new NumericLabel("d =", id, Label.LEFT);
		d.setFont(numFont);
		numbers.add(d);
		
		e = new NumericLabel("e =", ie, Label.LEFT);
		e.setFont(numFont);
		numbers.add(e);
		
		cosA = new NumericLabel("cosA =", icosA, Label.LEFT);
		cosA.setFont(numFont);
		numbers.add(cosA);
		
		cosB = new NumericLabel("cosB =", icosB, Label.LEFT);
		cosB.setFont(numFont);
		numbers.add(cosB);
		
		sinA = new NumericLabel("sinA =", isinA, Label.LEFT);
		sinA.setFont(numFont);
		numbers.add(sinA);
		
		sinB = new NumericLabel("sinB =", isinB, Label.LEFT);
		sinB.setFont(numFont);
		numbers.add(sinB);
		
		add("Center", numbers);

		parent = parentIn;

		validate();
		pack();
	}
	
	public void SetAnswers(double ia, double ib, double ic, 
			       double id, double ie,
			       double icosA, double icosB, 
			       double isinA, double isinB)
	{
		a.setNumber(ia);
		b.setNumber(ib);
		c.setNumber(ic);
		d.setNumber(id);
		e.setNumber(ie);
		cosA.setNumber(icosA);
		cosB.setNumber(icosB);
		sinA.setNumber(isinA);
		sinB.setNumber(isinB);
	}
	
	public Dimension preferredSize()
	{
		return new Dimension(FRAME_WIDTH, FRAME_HEIGHT);
	}
	
	public Dimension minimumSize()
	{
		return new Dimension(FRAME_WIDTH, FRAME_HEIGHT);
	}

	public boolean action (Event e, Object arg) {
	  if (e.target.equals(closeButton)) {
	    hide();
	    parent.deliverEvent(e);
	    return false;
	  }
	  return false;
	}

}
